<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
namespace App\Presenters;

use Nette,
	App\Model;
use  Nette\Application\UI;
use \Mesour\DataGrid\Grid,
	\Mesour\DataGrid\BasicGrid,
	\Mesour\DataGrid\NetteDbDataSource,
	\Mesour\DataGrid\Components\Link;

class EditFirmaPresenter extends UI\Presenter {
    /**
     *
     * @inject 
     * @var \App\Model\MujModel
     */
    public $muj_model;
    
    protected function createComponentEditFirmaForm(){
        $form = new Nette\Application\UI\Form;
        $form->addText('nazev', 'Firma:')
            ->setRequired('Název firmy musí být vyplněn');
        $form->addText('pravni_forma', 'Právní forma:');
        $form->addText('datum_zapisu', 'Datum zápisu(DD.MMMM YYYY):');
        $form->addText('pocet_zamestnancu', 'Počet zaměstnanců:')
               ->addCondition($form::FILLED)
               ->addRule($form::FLOAT, 'Počet zaměstnanců musí být číslo:' );
        $form->addText('zakladni_kapital', 'Základní kapitál:')
               ->addCondition($form::FILLED)
               ->addRule($form::FLOAT, 'Základní kapitál musí být číslo:');     
        $form->addText('ico','ičo:');
        $form->addText('dic', 'dič:');
        $form->addText('mesto','Město:');
        $form->addText('ulice', 'Ulice:');
        $form->addText('cislo_popisne','Číslo popisné:');
        $form->addText('psc', 'PSČ');   
        $form->addSubmit('send', 'Uložit')->setAttribute('class','btn submit');
        $form->onSuccess[] = array($this, 'editFirmaFormSucceeded');
        $form->addSubmit('cancel', 'Cancel')->setAttribute('class', 'btn cancel')
            ->setValidationScope(FALSE)
            ->onClick[] = array($this, 'cancelFirma');
        return $form;
    }

    public function cancelFirma(){
        $this->redirect('Homepage:default');
    }

    public function editFirmaFormSucceeded($form, $values){
        $this->muj_model->getTable('firmy')->insert($values);
        $this->flashMessage("Firma byla vložena.", 'success');
        $this->redirect('Homepage:default');
    }

    protected function createComponentEditKontaktyForm(){
        $form = new Nette\Application\UI\Form;
        $firma = $this->muj_model->findAll()->fetchPairs('id', 'nazev');
        $kontakt = $this->muj_model->findAllTypKontakt()->fetchPairs('id', 'typ');

        $form->addSelect('firmy_id', 'Firma:', $firma)
                ->setPrompt('-vyber firmu-')
                ->setRequired('Vyber firmu!');
        $form->addSelect('typy_kontaktu_id', 'Typ kontaktu:', $kontakt)
               ->setPrompt('-vyber kontakt-')
               ->setRequired('Vyber typ kontaktu!');
        $form->addText('kontakt', 'Kontakt:')
                ->setRequired('Kontakt musí být vyplněn');
        $form->addTextArea('poznamka', 'Poznámka:')->setAttribute('cols', 50)
        ->setAttribute('rows', 4);

        $form->addSubmit('send', 'Uložit')->controlPrototype->class('btn submit');
        $form->onSuccess[] = array($this, 'editKontaktyFormSucceeded');  

        $form->addSubmit('cancel', 'Cancel')->setAttribute('class', 'btn cancel')
            ->setValidationScope(FALSE)
            ->onClick[] = array($this, 'cancelKontakt');

        return $form;
    }

    public function cancelKontakt(){
        $this->redirect('Homepage:default');
    }

    public function editKontaktyFormSucceeded($form, $values)
    {
        $this->muj_model->getTable('kontakty')->insert($values);
        $this->flashMessage("Kontakt byl úspěšně vložen.", 'success');
        $this->redirect('Homepage:default');
    }

    protected function createComponentEditPobockyForm()
    {
        $form = new Nette\Application\UI\Form;
        $firma = $this->muj_model->findAll()->fetchPairs('id', 'nazev');           
        $form->addSelect('firmy_id', 'Firma:', $firma)
         ->setPrompt('-vyber firmu-')
         ->setRequired('Vyber firmu!');
        $form->addText('nazev', 'Pobočka:')
            ->setRequired('Název pobočky musí být vyplněn!');
        $form->addTextArea('komentar','Poznámka:')->setAttribute('cols', 50)
               ->setAttribute('rows', 4);
        $form->addText('mesto', 'Město:');
        $form->addText('ulice', 'Ulice:');
        $form->addText('cislo_popisne','Číslo popisné:');
        $form->addText('psc','psč');
        $form->addSubmit('send', 'Uložit')->setAttribute('class', 'btn submit');
        $form->onSuccess[] = array($this, 'editPobockyFormSucceeded'); 
        $form->addSubmit('cancel', 'Cancel')->setAttribute('class', 'btn cancel')
            ->setValidationScope(FALSE)
            ->onClick[] = array($this, 'cancelPobocky');
        return $form;
    }

    public function cancelPobocky(){
        $this->redirect('Homepage:default');
    }

    public function editPobockyFormSucceeded($form, $values){
        $this->muj_model->getTable('pobocky')->insert($values);
        $this->flashMessage("Pobočka byla úspěšně vložena.", 'success');
        $this->redirect('Homepage:default');
    }

    protected function createComponentEditSpolecniciForm(){
        $form = new Nette\Application\UI\Form;
        $firma = $this->muj_model->findAll()->fetchPairs('id', 'nazev');
        $form->addSelect('firmy_id', 'Firma:', $firma)
             ->setPrompt('-vyber firmu-')
             ->setRequired('Vyber firmu!');
        $form->addText('osoba', 'Osoba:')
            ->setRequired('Jméno osoby musí být vyplněno!');
        $form->addTextArea('dalsi_firmy', 'Další firmy:')->setAttribute('cols', 50)
                ->setAttribute('rows', 4);
        $form->addText('pozice', 'Pozice:');        
        $form->addText('podil','Podil ve tvaru číslo(procento):'); 
        $form->addSubmit('send', 'Uložit')->setAttribute('class','btn submit');
        $form->onSuccess[] = array($this, 'editSpolecniciFormSucceeded'); 
        $form->addSubmit('cancel', 'Cancel')->setAttribute('class','btn cancel')
            ->setValidationScope(FALSE)
            ->onClick[] = array($this, 'cancelSpolecnici');
        return $form;
    }

    public function cancelSpolecnici(){
        $this->redirect('Homepage:default');
    }

    public function editSpolecniciFormSucceeded($form, $values){
        $this->muj_model->getTable('spolecnici')->insert($values);
        $this->flashMessage("Společník byl úspěšně vložen.", 'success');
        $this->redirect('Homepage:default');
    }
    
}